﻿using System;
using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Metadata;

// Code scaffolded by EF Core assumes nullable reference types (NRTs) are not used or disabled.
// If you have enabled NRTs for your project, then un-comment the following line:
// #nullable disable

namespace SalesforceAPI.Models
{
    public partial class CustomerContext : DbContext
    {
        public CustomerContext()
        {
            Database.AutoTransactionsEnabled = false;
        }

        public CustomerContext(DbContextOptions<CustomerContext> options)
            : base(options)
        {
            Database.AutoTransactionsEnabled = false;
        }

        public virtual DbSet<CustomerC> CustomerC { get; set; }

        protected override void OnConfiguring(DbContextOptionsBuilder optionsBuilder)
        {
            if (!optionsBuilder.IsConfigured)
            {
#warning To protect potentially sensitive information in your connection string, you should move it out of source code. See http://go.microsoft.com/fwlink/?LinkId=723263 for guidance on storing connection strings.
                optionsBuilder.UseSalesforce("Username = preet@comptest.com; Password = test@123456789; Security Token = oWqvtzSQLLOBhBn7okpGCMmC4; OAuth Client Id = 3MVG9n_HvETGhr3DQYdXMQ1VzdyP0WXnoYsoSGwe4h2te4Xyq_uhjRGEPnH3cbmT4vR6cZTq8UKJIpoO3xZRc; OAuth Client Secret = 0AE751D6302D1FAC91EA347082D630D858B2C85E5C3A9695A24FD55F25F31B40; OAuth Token Endpoint = https://ap16.salesforce.com/services/oauth2/token; Url=https://ap16.salesforce.com/services/data/v42.0; Use Cache = 'true'; Cache provider = 'Microsoft.Data.SqlClient'; Cache connection = 'Server=10.64.1.28;Database=New_DataBase;User Id=sa;Password=grapecity@123;'");
            }
        }

        protected override void OnModelCreating(ModelBuilder modelBuilder)
        {
            modelBuilder.Entity<CustomerC>(entity =>
            {
                entity.ToTable("Customer__c");

                entity.Property(e => e.Id).ValueGeneratedOnAdd();

                entity.Property(e => e.AddressC).HasColumnName("Address__c");

                entity.Property(e => e.CityC).HasColumnName("City__c");

                entity.Property(e => e.CompanyNameC).HasColumnName("Company_Name__c");

                entity.Property(e => e.ContactNameC).HasColumnName("Contact_Name__c");

                entity.Property(e => e.ContactTitleC).HasColumnName("Contact_Title__c");

                entity.Property(e => e.CountryC).HasColumnName("Country__c");

                entity.Property(e => e.CreatedById)
                    .IsRequired()
                    .ValueGeneratedOnAddOrUpdate();

                entity.Property(e => e.CreatedDate).ValueGeneratedOnAddOrUpdate();

                entity.Property(e => e.CustomerIdC).HasColumnName("Customer_ID__c");

                entity.Property(e => e.FaxC).HasColumnName("Fax__c");

                entity.Property(e => e.IsDeleted).ValueGeneratedOnAddOrUpdate();

                entity.Property(e => e.LastActivityDate).ValueGeneratedOnAddOrUpdate();

                entity.Property(e => e.LastModifiedById)
                    .IsRequired()
                    .ValueGeneratedOnAddOrUpdate();

                entity.Property(e => e.LastModifiedDate).ValueGeneratedOnAddOrUpdate();

                entity.Property(e => e.LastReferencedDate).ValueGeneratedOnAddOrUpdate();

                entity.Property(e => e.LastViewedDate).ValueGeneratedOnAddOrUpdate();

                entity.Property(e => e.OwnerId).IsRequired();

                entity.Property(e => e.PhoneC).HasColumnName("Phone__c");

                entity.Property(e => e.PostalCodeC).HasColumnName("Postal_Code__c");

                entity.Property(e => e.RegionC).HasColumnName("Region__c");

                entity.Property(e => e.SystemModstamp).ValueGeneratedOnAddOrUpdate();
            });

            OnModelCreatingPartial(modelBuilder);
        }

        partial void OnModelCreatingPartial(ModelBuilder modelBuilder);
    }
}
