using Microsoft.AspNetCore.Builder;
using Microsoft.AspNetCore.Hosting;
using Microsoft.AspNetCore.HttpsPolicy;
using Microsoft.AspNetCore.Mvc;
using Microsoft.EntityFrameworkCore;
using Microsoft.Extensions.Configuration;
using Microsoft.Extensions.DependencyInjection;
using Microsoft.Extensions.Hosting;
using Microsoft.Extensions.Logging;
using SalesforceAPI.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace SalesforceAPI
{
    public class Startup
    {
        public Startup(IConfiguration configuration)
        {
            Configuration = configuration;
        }

        public IConfiguration Configuration { get; }

        // This method gets called by the runtime. Use this method to add services to the container.
        public void ConfigureServices(IServiceCollection services)
        {
            services.AddControllers();

            //string connectionString = @"Username = preet@comptest.com; Password = test@123456789; Security Token = oWqvtzSQLLOBhBn7okpGCMmC4; OAuth Client Id = 3MVG9n_HvETGhr3DQYdXMQ1VzdyP0WXnoYsoSGwe4h2te4Xyq_uhjRGEPnH3cbmT4vR6cZTq8UKJIpoO3xZRc; OAuth Client Secret = 0AE751D6302D1FAC91EA347082D630D858B2C85E5C3A9695A24FD55F25F31B40; OAuth Token Endpoint = https://ap16.salesforce.com/services/oauth2/token; Url=https://ap16.salesforce.com/services/data/v42.0; 
            //Use Cache = 'true'; Cache provider = 'Microsoft.Data.SqlClient'; Cache connection = 'Server=10.64.1.28;Database=New_DataBase;User Id=sa;Password=grapecity@123;'";
            string connectionString = @"Username = preet@comptest.com; Password = test@123456789; Security Token = oWqvtzSQLLOBhBn7okpGCMmC4; OAuth Client Id = 3MVG9n_HvETGhr3DQYdXMQ1VzdyP0WXnoYsoSGwe4h2te4Xyq_uhjRGEPnH3cbmT4vR6cZTq8UKJIpoO3xZRc; OAuth Client Secret = 0AE751D6302D1FAC91EA347082D630D858B2C85E5C3A9695A24FD55F25F31B40; OAuth Token Endpoint = https://ap16.salesforce.com/services/oauth2/token; Url=https://ap16.salesforce.com/services/data/v42.0;";
            services.AddDbContext<CustomerContext>(opt => opt.UseSalesforce(connectionString));
        }

        // This method gets called by the runtime. Use this method to configure the HTTP request pipeline.
        public void Configure(IApplicationBuilder app, IWebHostEnvironment env)
        {
            if (env.IsDevelopment())
            {
                app.UseDeveloperExceptionPage();
            }
            
            //Adding Static Files Middleware to serve the static files
            app.UseStaticFiles();

            app.UseHttpsRedirection();

            app.UseRouting();

            app.UseAuthorization();

            app.UseEndpoints(endpoints =>
            {
                endpoints.MapControllers();
            });
        }
    }
}
